package fr.mrdev023.vulkan_java.vk;

import java.util.HashMap;
import java.util.Optional;

public class QueueFamilyIndices {
    private final Optional<Integer> graphicsQueueFamilyIndex;
    private final Optional<Integer> computeQueueFamilyIndex;
    private final Optional<Integer> transferQueueFamilyIndex;
    private final Optional<Integer> presentQueueFamilyIndex;

    public QueueFamilyIndices(Optional<Integer> graphicsQueueFamilyIndex, Optional<Integer> computeQueueFamilyIndex,
            Optional<Integer> transferQueueFamilyIndex, Optional<Integer> presentQueueFamilyIndex) {
        this.graphicsQueueFamilyIndex = graphicsQueueFamilyIndex;
        this.computeQueueFamilyIndex = computeQueueFamilyIndex;
        this.transferQueueFamilyIndex = transferQueueFamilyIndex;
        this.presentQueueFamilyIndex = presentQueueFamilyIndex;
    }

    public Optional<Integer> getGraphicsQueueFamilyIndex() {
        return graphicsQueueFamilyIndex;
    }

    public Optional<Integer> getComputeQueueFamilyIndex() {
        return computeQueueFamilyIndex;
    }

    public Optional<Integer> getTransferQueueFamilyIndex() {
        return transferQueueFamilyIndex;
    }

    public Optional<Integer> getPresentQueueFamilyIndex() {
        return presentQueueFamilyIndex;
    }

    public static class Builder {
        private Optional<Integer> graphicsQueueFamilyIndex;
        private Optional<Integer> computeQueueFamilyIndex;
        private Optional<Integer> transferQueueFamilyIndex;
        private Optional<Integer> presentQueueFamilyIndex;

        public Builder withGraphicsQueueFamilyIndex(int graphicsQueueFamilyIndex) {
            this.graphicsQueueFamilyIndex = Optional.of(graphicsQueueFamilyIndex);
            return this;
        }

        public Builder withComputeQueueFamilyIndex(int computeQueueFamilyIndex) {
            this.computeQueueFamilyIndex = Optional.of(computeQueueFamilyIndex);
            return this;
        }

        public Builder withTransferQueueFamilyIndex(int transferQueueFamilyIndex) {
            this.transferQueueFamilyIndex = Optional.of(transferQueueFamilyIndex);
            return this;
        }

        public Builder withPresentQueueFamilyIndex(int presentQueueFamilyIndex) {
            this.presentQueueFamilyIndex = Optional.of(presentQueueFamilyIndex);
            return this;
        }

        public QueueFamilyIndices build() {
            return new QueueFamilyIndices(graphicsQueueFamilyIndex, computeQueueFamilyIndex, transferQueueFamilyIndex,
                    presentQueueFamilyIndex);
        }
    }
}
