package fr.mrdev023.vulkan_java.vk.loggers;

import java.util.Optional;

import fr.mrdev023.vulkan_java.vk.QueueFamilyIndices;

public class QueueFamilyRequirementResultLogger {
    public static void log(Optional<QueueFamilyIndices> queueFamilyIndices) {
        ScopedLogger.pushScope("Queue Family Requirements (Is suitable: {})", queueFamilyIndices.isPresent());
        logQueueFamilyResult("Graphics Queue",
                queueFamilyIndices.flatMap(QueueFamilyIndices::getGraphicsQueueFamilyIndex));
        logQueueFamilyResult("Compute Queue",
                queueFamilyIndices.flatMap(QueueFamilyIndices::getComputeQueueFamilyIndex));
        logQueueFamilyResult("Transfer Queue",
                queueFamilyIndices.flatMap(QueueFamilyIndices::getTransferQueueFamilyIndex));
        logQueueFamilyResult("Present Queue",
                queueFamilyIndices.flatMap(QueueFamilyIndices::getPresentQueueFamilyIndex));
        ScopedLogger.popScope();
    }

    private static void logQueueFamilyResult(String queueName, Optional<Integer> queueFamilyIndex) {
        if (queueFamilyIndex.isPresent()) {
            ScopedLogger.log("{}: [SUPPORTED] (Index: {})", queueName, queueFamilyIndex.get());
        } else {
            ScopedLogger.log("{}: [UNSUPPORTED]", queueName);
        }
    }
}
