package fr.mrdev023.vulkan_java.vk.loggers;

import java.util.ArrayDeque;
import java.util.Deque;
import java.util.stream.Collectors;

import org.tinylog.Logger;

public class ScopedLogger {
    private static Deque<String> scopes = new ArrayDeque<>();
    
    public static void pushScope(final String message, final Object... arguments) {
        log(message, arguments);
        scopes.push(message);
    }

    public static void log(final String message, final Object... arguments) {
        Logger.info(String.format("%s%s", getIndentation(), message), arguments);
    }

    public static void popScope() {
        scopes.pop();
    }

    private static String getIndentation() {
        return scopes.stream().map(s -> "  ").collect(Collectors.joining());
    }
}
